// This file contains declarations of variables that are actually defined
// in ear_globals.h.  Comments on what the variables are for are in
// ear_globals.h.

//---- preferences
extern struct {
  int note_names;
  int chord_names;
} preferences;

extern int open_voicings_allowed;
extern int inversions_allowed;

extern int spell_dim7_enharmonically;

extern complete_window *where_is_about_chord_complete_window;


//---------------- mac sound stuff --------------------------
extern unsigned char my_wave_table[];
extern int wave_table_size;
extern int have_wave_table;
extern int have_temp_wave_table;
extern int pitch_offset;
extern long init_chan_list[];
extern short kind_of_chan_list[];
extern SndChannelPtr my_snd_chan[];
extern int made_snd_chan[];
extern int chans_used;

extern int have_sample_storage;
extern Handle sound_handle;


extern short normal_font_size;
extern Style normal_text_face;
extern short normal_font;

extern int n_windows;
extern complete_window *my_windows[MAX_WINDOWS];

extern int interval_window_exists;
extern int chord_window_exists;
extern int about_ear_training_window_exists;
extern int chord_help_window_exists;
extern int about_chord_window_exists;
extern int sing_interval_window_exists;
extern int inversions_window_exists;
extern int chord_functions_window_exists;

extern int interval_is_in_major_scale[];
extern int interval_is_in_minor_scale[];
extern int interval_is_in_harmonic_minor_scale[];

extern int have_previous_chord;
extern int previous_n_items,previous_item[MAX_CHORD_ITEMS];
extern int previous_n_notes,previous_chord[MAX_CHORD_ITEMS];
extern int previous_root;
extern int about_chord_window_exists;

//-- other stuff:

extern int difficulty;
