// ==================================================
//	myMime.h
//	Copyright (C) 1996 Mizutori Tetsuya, August 20, 1996.
// ==================================================
//	This document is pretty-printed in 10-point Geneva font.

//#define MIME_ENCODE	TRUE
#define MIME_DECODE	TRUE


#ifdef MIME_ENCODE
static unsigned long	CalcMimeEncodeLength(
			unsigned long		textSize );

void	MimeEncode(
			Handle			textH,
			unsigned long *		textSize );

void	MimeEncodeJIS(
			Handle			textH,
			unsigned long *		textSize );

unsigned long	MimeEncodeText(
			unsigned char *		inTextP,
			unsigned long		inTextSize,
			unsigned char *		outTextP,
			unsigned long *		outTextSize );

static void	Base64EncodeBody(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			unsigned char *		qStart,
			unsigned long *		qLen );

static void	Base64Encode324(
			const unsigned char *	p3,
			const unsigned long	pLen,
			unsigned char *		q4 );

#endif // MIME_ENCODE


#ifdef MIME_DECODE
void	MimeDecode(
			Handle			textH,
			unsigned long *		textSize );

unsigned long	MimeDecodeText(
			unsigned char *		inTextP,
			unsigned long		inTextSize,
			unsigned char *		outTextP,
			unsigned long *		outTextSize );

static void	Base64DecodeBody(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			unsigned char *		qStart,
			unsigned long *		qLen );

static void	Base64Decode423(
			const unsigned char *	p4,
			unsigned char *		q3,
			unsigned long *		qLen );
#endif // MIME_DECODE

static Boolean	GetToken(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			const unsigned char *	token,
			const unsigned long	tokenLen,
			unsigned long *		index );

static Boolean	IsSameString(
			const unsigned char *	strA,
			const unsigned long	strALen,
			const unsigned char *	strB,
			const unsigned long	strBLen );

static unsigned long	CStrlen(
			const unsigned char *	str );

#ifdef MIME_ENCODE
static unsigned long	AppendText(
			unsigned char *		pStart,
			unsigned char *		pEnd,
			Handle			textH,
			unsigned long *		textSize );
#endif // MIME_ENCODE

// end of definition
