/*============================================================

					N_Number sample program
					
============================================================*/

#include	"N_Library.h"

WindowPtr 	CreateWindow 		(Str255 name);


#define		WindowSizeX		640
#define		WindowSizeY		480

short		NewWindowX;
short		NewWindowY;

short		Data_Rsrc = 0;

short		Snd_List0[] 	= {1000,1001,0};

long		counter1		 = 2000;												//counter
long		counter2		 = 2000;
long		counter3		 = 2000;



void main(void)
{
	WindowPtr	window;
	short		bt;

	ToolboxInit();
	ColorCheck();
	window = CreateWindow("\pN Game Library <Button Sample>");
	N_Window_Set(window,NewWindowX,NewWindowY,WindowSizeX,WindowSizeY);			//set up window
	Open_Resource_File(128,1,&Data_Rsrc);
	N_Pict_Draw(128,0,0,(GrafPtr)Main_Window,false);
	N_Pict_Draw(128,0,0,(GrafPtr)Main_Window,true);								//draw background
	
	N_Button_Init();															//initialize button set
	N_Font_Init();
	N_Sprite_Set(129,0,14,24,1,11,1,0);											//set 11sprites (Sp 0 - 10)for number 
	N_Sprite_Set(130,11,32,32,1,6,1,0);											//set 6sprites  (Sp 11 - 16)for button

	N_Sound_Load(&Snd_List0[0]);	

	N_Font_Set(0,0,0,0,0);														//initialize font set
	Close_Resource_File(&Data_Rsrc);

	N_Button_Set(0,0,0,40,410,0,11,12,1000,1001);									//set up buttons
	N_Button_Set(0,1,0,80,410,0,13,14,1000,1001);

	N_Button_Set(0,2,0,160,410,40,11,12,1000,1001);
	N_Button_Set(0,3,0,200,410,40,13,14,1000,1001);

	N_Button_Set(0,4,0,280,410,512,11,12,1000,1001);
	N_Button_Set(0,5,0,320,410,512,13,14,1000,1001);

	N_Button_Set(0,6,0,410,410,513,15,16,1000,1001);
	N_Button_Set(0,7,0,470,410,514,15,16,1000,1001);

	N_Button_Set(0,8,0,562,410,512,15,16,1000,1001);								//set Quit button
	N_Button_Put(0);

	N_Num_Put(counter1,30,320,5,16,0,0,0);										//put counters
	N_Num_Put(counter2,150,320,5,16,0,0,0);
	N_Num_Put(counter3,270,320,5,16,0,0,0);
	
	do
	{
		bt = N_Button_Check(0);
	
		if (bt == 1) counter1++;
		if (bt == 3) counter2++;
		if (bt == 5) counter3++;

		if (counter1 == 10000) counter1 = 0;
		if (counter2 == 10000) counter2 = 0;
		if (counter3 == 10000) counter3 = 0;
	
		if (bt == 0) counter1--;
		if (bt == 2) counter2--;
		if (bt == 4) counter3--;
	
		if (counter1 == -1) counter1 = 9999;
		if (counter2 == -1) counter2 = 9999;
		if (counter3 == -1) counter3 = 9999;
	
		if(bt != -1)
		{
			N_Num_Put(counter1,30,320,5,16,0,0,0);								//updates counters
			N_Num_Put(counter2,150,320,5,16,0,0,0);
			N_Num_Put(counter3,270,320,5,16,0,0,0);
		}
	
	}
	while (bt != 8);																//push quit button?
	N_Sound_Close();															//close sound channels
	ColorRevert();
}

WindowPtr CreateWindow (Str255 name)
{
	WindowPtr	window;
	short		centerX,centerY;
	short		windowWidth,windowHeight;


	window = GetNewWindow (128,nil,(WindowPtr)-1L );
	centerX  = (qd.screenBits.bounds.right -qd.screenBits.bounds.left)/2;
	centerY  = (qd.screenBits.bounds.bottom -qd.screenBits.bounds.top)/2;
	SetWTitle(window,name);
	MoveWindow(window,NewWindowX=centerX-(WindowSizeX/2),NewWindowY=centerY-(WindowSizeY/2),false);
	SizeWindow(window,WindowSizeX,WindowSizeY,TRUE);

	ShowWindow(window);
	SetPort((GrafPtr)window );
	return (WindowPtr)window;
}
	

