#define MIDDLE_C 60
		// mac uses midi values
		
#define MAX_STR_LEN 300
					//... for string-handling routines
#define WAVE_TABLE_SIZE 512
					//... max size for waveform tables
#define NCHAN 4
					//... number of channels of sound
#define MAX_WINDOWS 10
#define MAX_INTERVAL 15

#define MAX_CHORD_ITEMS 20	
#define MAX_CHORD_NOTES (MAX_CHORD_ITEMS+5)	

#define MAX_DIFFICULTY 20
		//... for the global variable difficulty
//----- preferences
#define PEDANTIC_NOTE_NAMES 0
#define SIMPLE_NOTE_NAMES 1
#define NORMAL_CHORD_NAMES 0
#define CHORD_SOLFEG_SYSTEM 1
//------ resource IDs:
#define MBAR_ID 128
#define APPLE_MENU_ID 128
#define FILE_MENU_ID 129
#define EDIT_MENU_ID 130
#define WORKOUTS_MENU_ID 131
#define OPTIONS_MENU_ID 132
#define PREFERENCES_MENU_ID 133

#define INTERVAL_DLOG_ID 128
#define CHORD_DLOG_ID 129
#define INVERSIONS_DLOG_ID 137
#define SING_INTERVAL_DLOG_ID 136
#define CHORD_FUNCTIONS_DLOG_ID 138
	//...this is also assumed to be the resource id of the corresponding STR
	//	resource containing the nifty decoder string	
	//	18 Nov 95: decoder string for chords is now in source code, not resource
#define SELECT_INTERVAL_MODAL_DLOG_ID 130
#define SELECT_INITIAL_WORKOUT_MODAL_DLOG_ID 131
#define ABOUT_EAR_TRAINING_DLOG_ID 132
#define CHORD_HELP_DLOG_ID 133
#define ABOUT_CHORD_DLOG_ID 134
#define VOLUME_MODAL_DLOG_ID 135
#define DIFFICULTY_MODAL_DLOG_ID 139

#define BLANK_ICON_ID 128
#define CHECK_ICON_ID 129
#define X_ICON_ID 130

//------ chord symbols
// Notes: I assume in simplify_chord() that basic triads and 7th chords with
//	lower numbers are simpler that ones with higher numbers.
#define CHORD_MAJ_TRIAD 	1
#define CHORD_MIN_TRIAD 	2
#define CHORD_DIM_TRIAD 	3
#define CHORD_AUG_TRIAD 	4
#define CHORD_SUS_TRIAD 	5
#define CHORD_FLAT5_TRIAD 	6
#define CHORD_DOM7 		101
#define CHORD_MIN7 		102
#define CHORD_MAJ7 		103
#define CHORD_DIM7 		104
#define CHORD_HALF_DIM 		105
#define CHORD_FLAT9 		201
#define CHORD_9 		202
#define CHORD_SHARP9 		203
#define CHORD_11 		205
#define CHORD_SHARP11 		206
#define CHORD_FLAT6 		208
#define CHORD_6			209
#define CHORD_ADD7		210
#define CHORD_ADDMAJ7		211
#define CHORD_NO1		301
#define CHORD_NO3		302
#define CHORD_NO5		303
#define LO_TRIAD		1
#define HI_TRIAD		6
#define LO_7TH_CHORD		101
#define HI_7TH_CHORD		105
#define LO_ADDED_TONE		201
#define HI_ADDED_TONE		211
#define LO_OMITTED_TONE		301
#define HI_OMITTED_TONE		303
