
//
//    generic stuff that isn't specific to the mac or to this program
//

typedef signed char    BYTE_T;
typedef signed short   WORD_T;
typedef signed long    LONG_T;
typedef unsigned char  UBYTE_T;
typedef unsigned short UWORD_T;
typedef unsigned long  ULONG_T;

#define EVEN_ADDRESS(x) (!(((unsigned long) (x)) & 1L))
#define VALID_POINTER(x) \
	( (((char *) (x))!=((char *) 0)) && (((char *) (x))!=((char *) -1)) )
#define VALID_HANDLE(x) (VALID_POINTER(x) && EVEN_ADDRESS(x) \
	&& VALID_POINTER(* (char **) (x)) )

typedef int FUNCTION_RETURNING_INT();
typedef void FUNCTION_RETURNING_VOID();
